package commands

type BaseCommand struct {
	Help HelpCommand `command:"help" description:"Print this help message"`

	DecryptDBF DecryptDBFCommand `command:"decrypt-dbf" description:"decrypt dbf-data"`
	DecryptDES DecryptDESCommand `command:"decrypt-des" description:"decrypt des-data"`

	//CodePlugModify
	//CodePlugUnify
	//CodePlugToJSON
	//CodePlugFromJSON

	//CodePlugFlash
	//CodePlugDump

	//KernelModifyFile
	//KernelRepack

	MparUnpack MparUnpackCommand `command:"mpar-unpack" description:"Extracts the Raw Binary Data from an Partition-File"`
	MparPack   MparPackCommand   `command:"mpar-pack" description:"Creates a new Partition-File from Raw Binary-Data"`

	S19Tree                 S19TreeCommand                 `command:"s19-tree" description:"Dump the S19 Record Tree and seperate Memory Regions"`
	S19IsolatePart          S19IsolatePartitionCommand     `command:"s19-isolate-part" description:"Isolate a Partition from an S19-File"`
	S19IsolateAllPartitions S19IsolateAllPartitionsCommand `command:"s19-isolate-all-part" description:"Isolate all available Partitions from an S19-File"`
	S19FromMpar             S19FromMparCommand             `command:"s19-from-mpar" description:"Creates a new S19-File from a Partition-File"`

	MparPaxList    MparPaxListCommand    `command:"mpar-pax-list" description:"prints the contents of an pax archive within an mpar"`
	MparPaxExtract MparPaxExtractCommand `command:"mpar-pax-extract" description:"extracts a single file from an pax'd mpar file"`
	MparPaxReplace MparPaxReplaceCommand `command:"mpar-pax-replace" description:"replaces a single file in a pax'd mpar file"`
	MparPaxInsert  MparPaxInsertCommand  `command:"mpar-pax-insert" description:"inserts a single file in a pax'd mpar file"`
}

var MotoCLI BaseCommand
